import { VNode, VNodeChildren } from 'vue';
import { ValidationMessages, ValidationTranslator } from '../type';
export declare type ComponentFormMethods<T = Record<string, any>> = {
    submit: () => Promise<void>;
    [key: string]: any;
};
export declare type ComponentFormComputed<T = Record<string, any>> = {
    isEditing: boolean;
    [key: string]: any;
};
export declare type ComponentFormData<T = Record<string, any>> = {
    busy: boolean;
    form: Partial<T> | null;
    [key: string]: any;
};
export declare type ComponentFormVuelidate<T = Record<string, any>> = {
    $v: {
        [key: string]: any;
        form: {
            [K in keyof T]: any;
        };
    };
};
export declare type FormGroupProps = {
    errors: string[];
    invalid: boolean;
};
export declare type FormBaseBuildContext<T extends Record<string, any> = Record<string, any>> = {
    title: string | VNode | (VNode | string)[] | VNodeChildren;
    propName: keyof T | string;
    attrs?: Record<string, any>;
    domProps?: Record<string, any>;
    changeCallback?: (input: any) => void;
    validationMessages?: ValidationMessages;
    validationTranslator?: ValidationTranslator;
};
export declare type FormInputBuildContext<T extends Record<string, any> = Record<string, any>> = FormBaseBuildContext<T>;
export declare type FormSelectOption = {
    id: string | number;
    value: any;
};
export declare type FormSelectBuildContext<T extends Record<string, any> = Record<string, any>> = FormBaseBuildContext<T> & {
    options: FormSelectOption[];
    optionDefaultText?: string;
};
export declare type FormSubmitOptions = {
    updateText?: string;
    updateIconClass?: string;
    updateButtonClass?: string;
    createText?: string;
    createIconClass?: string;
    createButtonClass?: string;
};
export declare type FormTextareaBuildContext<T extends Record<string, any> = Record<string, any>> = FormBaseBuildContext<T>;
//# sourceMappingURL=type.d.ts.map